﻿Public Class Row130913

#Region "プロパティ"

    Private _activeCell As Control = Nothing

#End Region

#Region "プロセス"

    ''' <summary>
    ''' アクティブコントロール取得
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function FNC_ACEL_GET() As Control
        Return _activeCell
    End Function

    ''' <summary>
    ''' アクティブコントロール設定
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <remarks></remarks>
    Public Sub FNC_ACEL_SET(ByVal cellName As String)
        Dim D_OBJ As Control
        '
        For Each D_OBJ In Me.Controls
            If D_OBJ.Name = cellName Then
                _activeCell = D_OBJ : Exit For
            End If
        Next
    End Sub

    ''' <summary>
    ''' マルチローに他コントロールからフォーカスが移ってきたときの処理
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub FNC_FST_ENT_MROW()
        If IsNothing(_activeCell) Then Exit Sub
        _activeCell.Focus()
    End Sub

    ''' <summary>
    ''' セル値取得
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function FNC_ITM_GET(ByVal cellName As String) As String
        Return UTL_Com.FindControl(Me, cellName).Text
    End Function

    ''' <summary>
    ''' セル値設定
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Public Sub FNC_ITM_SET(ByVal cellName As String, ByVal value As String)
        UTL_Com.FindControl(Me, cellName).Text = value
    End Sub

#End Region

#Region "ActiveControlChanged イベント"
    '参考：http://blogs.wankuma.com/jeanne/archive/2007/04/02/69804.aspx

    Private Sub ChildControls_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        DirectCast(sender, System.Windows.Forms.Control).Focus()
    End Sub

    Private Sub ChildControls_Enter(ByVal sender As Object, ByVal e As System.EventArgs)
        If sender Is Nothing Then
            Return
        End If

        If Not TypeOf sender Is System.Windows.Forms.Control Then
            Return
        End If

        Dim cControl As System.Windows.Forms.Control = DirectCast(sender, System.Windows.Forms.Control)
        '
        _activeCell = cControl
    End Sub

    Private Sub ChildControls_ControlAdded(ByVal sender As Object, ByVal e As System.Windows.Forms.ControlEventArgs) Handles Me.ControlAdded
        If e Is Nothing Then
            Return
        End If

        If e.Control Is Nothing Then
            Return
        End If

        AddHandler e.Control.Click, AddressOf ChildControls_Click
        AddHandler e.Control.ControlAdded, AddressOf ChildControls_ControlAdded
        AddHandler e.Control.ControlRemoved, AddressOf ChildControls_ControlRemoved
        AddHandler e.Control.Enter, AddressOf ChildControls_Enter
    End Sub

    Private Sub ChildControls_ControlRemoved(ByVal sender As Object, ByVal e As System.Windows.Forms.ControlEventArgs) Handles Me.ControlRemoved
        If e Is Nothing Then
            Return
        End If

        If e.Control Is Nothing Then
            Return
        End If

        RemoveHandler e.Control.Click, AddressOf ChildControls_Click
        RemoveHandler e.Control.ControlAdded, AddressOf ChildControls_ControlAdded
        RemoveHandler e.Control.ControlRemoved, AddressOf ChildControls_ControlRemoved
        RemoveHandler e.Control.Enter, AddressOf ChildControls_Enter
    End Sub

#End Region

End Class
